################################## IMPORTS PYTHON3 ##################################
import re #permet la manipulation des expressions régulières utilisées dans la fonction liste_lexicale et mkfor.
import os.path #gére la création du fichier de sortie du simulateur.

################################## DÉFINITION DES FONCTIONS ##################################
def arite(chaine,signature): #fonction permettant d'extraire l'arité d'une chaîne de caractère donnée. L'arité d'un opérateur est le nombre d'arguments ou d'opérandes qu'admet cet opérateur (ref : Eléments de mathématiques discrètes par Louis Frécon).
	if chaine in signature: 
		ari=signature[chaine] #si la chaîne de caractère est un opérateur rencensé dans le dictionnaire signature, alors on extrait son arité. Par exemple l'opérateur "or" est binaire car son arité vaut 2.
	else:	
		ari=0 #sinon l'arité de la chaîne de caractère est 0 car il ne s'agit pas d'un opérateur ou l'opérateur n'est pas rencensé dans signature.
	return ari

def liste_lexicale(F): #fonction qui transforme une formule sous forme de chaîne de caractère en formule sous forme de liste lexicale. Lors du parcours de la chaîne de caractère, si l'on rencontre un opérateur connu, il ne doit pas être fractionné en plusieurs caractères. 
	l=[] #l la liste lexicale.
	for i in range(0,(len(F))): #parcours caractère par caractère de la formule F sous forme de chaîne de caractères.
		if F[i]=='o' and F[i+1]=='r': #si l'on rencontre un "o" et qu'il est suivi d'un "r" alors on stocke l'opérateur "or" dans la liste l.
			l=l+[F[i]+F[i+1]]
		elif F[i]=='a' and F[i+1]=='n' and F[i+2]=='d': #si l'on rencontre un "a" et qu'il est suivi d'un "n" et d'un "d" alors on stocke l'opérateur "and" dans la liste l.
			l=l+[F[i]+F[i+1]+F[i+2]]
		elif F[i]=='n' and F[i+1]=='o' and F[i+2]=='t': #si l'on rencontre un "n" et qu'il est suivi d'un "o" et d'un "t" alors on stocke l'opérateur "not" dans la liste l.
			l=l+[F[i]+F[i+1]+F[i+2]]
		elif F[i]=='>' and F[i+1]=='=': #si l'on rencontre un ">" et qu'il est suivi d'un "=" alors on stocke l'opérateur ">=" dans la liste l.
			l=l+[F[i]+F[i+1]]
		else: #il faut gérer tous les cas où l'on lit la ou les lettre(s) suivant la première lettre de l'opérateur. En effet, si un opérateur est lu, il ne faut pas considérer cette lettre comme opérateur suivant car il aura déjà été considéré.
			if F[i]=='r' and F[i-1]=='o': #si l'on rencontre un "r" et que la lettre précédente est un "o", alors on aura déjà lu le "or" au pas précédent. Il faut ignorer cette lettre.
				l=l
			elif F[i]=='o' and F[i-1]=='n' and F[i+1]=='t': #si l'on rencontre un "o" et que la lettre précédente est un "n" et la suivante un "t", alors l'opérateur "not" aura déjà été lu. Il faut ignorer ce "o".
				l=l #on ignore la lettre lue.
			elif F[i]=='t' and F[i-1]=='o' and F[i-2]=='n': # "not" déjà lu, on ignore le "t"
				l=l
			elif F[i]=='n' and F[i-1]=='a' and F[i+1]=='d': #même principe pour "and".
				l=l
			elif F[i]=='d' and F[i-1]=='n' and F[i-2]=='a': #même principe pour "and".
				l=l
			elif F[i]=='=' and F[i-1]=='>': #même principe pour ">=".
				l=l
			#si l'utilisateur décide de proposer des noms de variables biologiques de plus de 1 caractère, il faut stocker le nom de la variable avant de l'ajouter dans la liste lexicale.
			elif (F[i]=='(') and (F[i-1]=='='): #si l'on encontre un "=" puis "(" alors on est certain de lire le nom de variable un indice plus loin, étant donné le resect de la syntaxe.
				l=l+[F[i]] #on stocke la parenthèse ouvrante dans la liste lexicale. 
				j=i+1 #on se place au niveau du 1er caractère du nom de la variable biologique. 
				var="" #on stocke le nom de la variable biologique dans var. 
				while F[j]!=',': #tant que l'on ne rencontre pas de ",",  ceci signifie que l'on a pas fini de lire le nom de la variable biologique.
					var=var+F[j] #alors on continue de stocker les caractères du nom de la variable biologique.
					j+=1
				l=l+[var] #on ajoute à la liste lexicale le nom entier de la variable biologique.
			elif (F[i]==',') and (re.search('[A-Za-z]+',F[i+1]) is None): #si l'on recontre une "," puis un caractère étant une lettre quelconque de l'alphabet (peu importe la casse), alors on est certain de lire un chiffre ou un nombre, un indice plus loin. 
				j=i+1
				num="" #on stocke la valeur entière dans la variable num. Cette valeur entière compose la proposition atomique. 
				while F[j]!=')': #tant qe l'on ne rencontre pas de ")", ceci signifie que l'on a pas fini de lire l'entier. 
					num=num+F[j] #alors on continue de stocker les chiffres de l'entier. 
					j+=1
				l=l+[num] #on ajoute à la liste lexicale l'entier correspondant. 
			elif (F[i]=='(') or (F[i]==')') or (F[i]==','): #Les autres cas à gérer sont : soit on rencontre une parenthèse ouvrante, une parenthèse fermante ou une virgule. 
				l=l+[F[i]] #dans ces cas là il faut stocker le caractère correspondant dans la liste lexicale. 
	return l

#exemple de liste lexicale : 
#['and', '(', '>=', '(', 'v', ',', '1', ')', ',', 'not', '(', '>=', '(', 'w', ',', '2', ')', ')', ')']
#v est une entité comparée au niveau discret 1. Il s'agit d'une proposition atomique.

i=0 #initialisation de la variable globale i. L'astuce est de réinitialiser i à chaque appel récursif.
def mkforrec(l): #la fonction mkforrec pour make formule. Cette fonction transforme une formule sous forme de liste, en formule sous forme d'arbre syntaxique.
	global i #portée globale de la variable i.
	form={} #initialisation du dictionnaire stockant les formules propositionnelles atomiques au niveau des feuilles de l'arbre.
	formule={} #l'arbre syntaxique 'formule' est structuré sous forme de dictionnaire.
	op=l[i] # stockage de la chaîne de caractère lue à l'indice i de la liste lexicale l. 
	i+=1 # l'incrémentation permet d'ignorer les parenthèses ouvrantes.
	f=[] #initialisation de la liste des fils d'un noeud de l'arbre syntaxique formule.
	a=arite(op,signature) #stockge de l'arité de la chaîne de caractère lue dans la liste lexicale.
	if a==0: #si l'arité vaut 0 alors la chaîne de caractère lue n'est pas un opérateur mais un opérande.
		if re.search('[0-9]+',op) is not None: #si la chaîne de caractère lue est un chiffre ou un nombre, 
			op=int(op) #alors la chaine de caractère est convertie en entier. Sinon, la chaîne de caractère reste inchangée.
		form['rac']=op # un opérande est considéré comme une feuille de l'arbre. Une feuille ne contient pas de fils. Toutes les entités étant des feuilles font partie d'une poposition atomique définie par le formalisme hybride de modélisation de réseaux de régulation biologique. 
		form['fils']=[]
		return form #le dictionnaire 'form' stocke les formules propositionnelles atomiques.
	else: #si l'arité de la chaîne de caractère op est différent de 0, alors on lit un opérateur recensé par le dictionnaire signature.
		i+=1 # l'incrémentation permet d'ignorer les parenthèses ouvrantes.
		while l[i]!=")": #tant que l'on a pas rencontré ni lu une proposition atomique composée d'une chaîne de caractère et d'un entier, alors de manière récursive on appelle la fonction mkfor.
			if l[i]==',': #avant d'appeler récursivement mkfor, il faut s'assurer que l'on ignore les virgules. 
				i+=1 #l'incrémentation permet d'ignorer une virgule.
			else:
				res=mkforrec(l) #appel récursif de mkforrec jusqu'à ce que l'on lise une proposition atomique (ex : v>=1 sous la forme de >=(v,1)). On finit de lire une proposition atomique lorsque l'on rencontre une 1ère parenthèse fermante.
				f=f+[res] #on stocke la proposition atomique
		i+=1 #l'incrémentation permet d'ignorer la vigule à la suite d'une parenthèse fermante.
		formule['rac']=op #retour sur l'opérateur lu 
		formule['fils']=f #stockage du (ou des) fils (opérande(s)) comme valeur de clé.
	return formule #formule est un arbre syntaxique sous forme de dictionnaire.
#exemple de résultat : {'rac': 'and', 'fils': [{'rac': '>=', 'fils': [{'rac': 'CB', 'fils': []}, {'rac': 30, 'fils': []}]}, {'rac': 'not', 'fils': [{'rac': '>=', 'fils': [{'rac': 'PC', 'fils': []}, {'rac': 2, 'fils': []}]}]}]}

def mkfor(l): #fonction permettant de réinitialiser i à 0 lorsque l'on utilise mkforrec de manière consécutive. On la distingue de mkfor : la fonction appelant récursivement mkforrec.
	global i 
	i=0
	return mkforrec(l) #initialise la variable globale i à 0 à la fin de l'éxecution de la fonction mkforrec. 

def remplacer(feuille,eta): 
	if type(feuille['rac'])==int: #si le fils est un entier,
		constante=feuille['rac'] #on stocke sa valeur dans la variable constante.
		return constante
	if type(feuille['rac'])==str: #si le fils est une chaîne de caractère, 
		variable=feuille['rac'] #alors il s'agit de l'entité comparée à un niveau discret dans la proposition atomique.
		return eta[variable] #on retourne sa valeur dans l'état courant pour la comparer à celle de la proposition atomique.

def eval(form,eta): #la fonction eval évalue une formule en entrée et renvoie True si elle est vérifiée dans l'état courant en entrée.
	if form['rac']=='>=': #si l'on retrouve l'opérateur ">=" alors on a atteint la proposition atomique. L'opérateur ">= a deux opérandes donc deux fils".
		l=form['fils'] 
		f1=l[0] #1er fils
		f2=l[1] #2nd fils
		res1=remplacer(f1,eta) #appel de la fonction remplacer pour le 1er fils : voir la fonction remplacer pour plus de détails.
		res2=remplacer(f2,eta) #appel de la fonction remplacer pou le second fils : voir la fonction remplacer pour plus de détails.
		return(res1>=res2) #comparaison de la la valeur de l'entité biologique dans la formule et celle dans l'état courant. Renvoie True ou False.
	elif form['rac']=='not': #si on ne lit pas l'opérateur de la proposition atomique (>=) alors, 
		l=form['fils'] #pour l'opérateur not on a 1 fils car 1 opérande.
		f1=l[0] #on récupère le fils c'est à dire le ou les opérande(s) de l'opérateur.
		return(not eval(f1,eta)) #appel récursif de eval jusqu'à ce qu'une proposition atomique soit lue. Renvoie True si la proposition est vérifiée. Sinon False.
	elif form['rac']=='or':
		l=form['fils'] #pour l'opérateur or on a 2 fils car 2 opérandes. 
		f1=l[0] 
		f2=l[1]
		return(eval(f1,eta) or eval(f2,eta)) #renvoie True si la proposition est vérifiée. Sinon False.
	elif form['rac']=='and':
		l=form['fils'] #l'opérateur or a 2 fils car 2 opérandes. 
		f1=l[0]
		f2=l[1]
		return(eval(f1,eta) and eval(f2,eta)) #renvoie True si la proposition est vérifiée. Sinon False.
	#si l'on souhaite ajouter d'autres règles, il est possible d'ajouter des conditions supplémentaires à cet endroit. 
	else: #si on lit un opérateur non recensé par le dictionnaire signature : message d'erreur. 
		print('Syntaxe logique incorrecte : veuillez réécrire la formule logique selon les conventions choisies.')


### SIGNATURE ###
signature={"or":2, "and":2, ">=":2, "not":1} #dictionnaire fournissant la signature d'un opérateur c'est à dire son nombre d'opérande. 
